# Scenario catalogue

## Scenarios without DIF

|                 | **J** |       | **Epsilon** |       |
| --------------  | ----- | ----- |  -----  |  -----  |
|                 | **4** | **7** | **0.2** | **0.5** |
| **Scenario 101** | X     |       | X     |       |
| **Scenario 102** | X     |       |       | X     |
| **Scenario 103** |       | X     | X     |       |
| **Scenario 104** |       | X     |       | X     |

Each scenario has 5 subscenarios:  

-   A - H<sub>0</sub> true
-   B - H<sub>1</sub> true, effect size 0.2
-   C - H<sub>1</sub> true, effect size 0.4
-   D - H<sub>1</sub> true, effect size -0.2
-   E - H<sub>1</sub> true, effect size -0.4

## Scenarios with DIF

|                 | **J** |       | **Epsilon** |       | **Nb items DIF** |       |       | **DIF size** |         |
| --------------- | ----- | ----- | ----- | ----- | ---------------- | ----- | ----- | -------------- | ------- |
|                 | **4** | **7** | **0.2** | **0.5** | **1**            | **2** | **3** | **0.3**        | **0.5** |
| **Scenario 105**  | X     |       | X     |       | X                |       |       | X              |         |
| **Scenario 106**  | X     |       |       | X     | X                |       |       | X              |         |
| **Scenario 107**  | X     |       | X     |       | X                |       |       |                | X       |
| **Scenario 108**  | X     |       |       | X     | X                |       |       |                | X       |
| **Scenario 109**  | X     |       | X     |       |                  | X     |       | X              |         |
| **Scenario 110** | X     |       |       | X     |                  | X     |       | X              |         |
| **Scenario 111** | X     |       | X     |       |                  | X     |       |                | X       |
| **Scenario 112** | X     |       |       | X     |                  | X     |       |                | X       |
| **Scenario 113** |       | X     | X     |       |                  | X     |       | X              |         |
| **Scenario 114** |       | X     |       | X     |                  | X     |       | X              |         |
| **Scenario 115** |       | X     | X     |       |                  | X     |       |                | X       |
| **Scenario 116** |       | X     |       | X     |                  | X     |       |                | X       |
| **Scenario 117** |       | X     | X     |       |                  |       | X     | X              |         |
| **Scenario 118** |       | X     |       | X     |                  |       | X     | X              |         |
| **Scenario 119** |       | X     | X     |       |                  |       | X     |                | X       |
| **Scenario 120** |       | X     |       | X     |                  |       | X     |                | X       |

Each scenario has 7 subscenarios:  

-   A - H<sub>0</sub> true, DIF -0.3/0.5 on traitement group    
    -   **MPR example**  
-   B - H<sub>1</sub> true, effect size 0.2, DIF +0.3/0.5 on traitement group  
    -   **BDI example**  
-   C - H<sub>1</sub> true, effect size 0.2, DIF -0.3/0.5 on traitement group  
    -   **Dentistry example**  
-   D - H<sub>1</sub> true, effect size 0.4, DIF +0.3/0.5 on traitement group  
    -   **BDI example**  
-   E - H<sub>1</sub> true, effect size 0.4, DIF -0.3/0.5 on traitement group  
    -   **Dentistry example**  
-   F -  H<sub>1</sub> true, effect size -0.2, DIF -0.3/0.5 on traitement group  
    -   **Adverse effects example**  
-   G -  H<sub>1</sub> true, effect size -0.4, DIF -0.3/0.5 on traitement group  
    -   **Adverse effects example**  


## Confusion simulation details

8 covariates are simulated for each scenario, each defined by their odds ratio on treatment and odds ratio on outcome:

**OR_TT^X**: Odds ratio describing the increase in probability of patients being treated when covariate X is positive.  
**OR_Y^X**: Odds ratio describing the increase in average outcome when covariate X is positive.  

Covariates are simulated as in *Sturmer et al, 2021*:


| **Variables** | **OR_TT^X** | **OR_Y^X** |
| --------------  | ----- | ----- |
| **X_1** | 2.0     |   1.0    |
| **X_2** | 1.5     |   1.0    |
| **X_3** | 1.0     |   2.0    |
| **X_4** | 1.0     |   1.5    |
| **X_5** | Epsilon |  Epsilon |
| **X_6** | 1.5 x Epsilon |  1.5 x Epsilon |
| **X_7** | 1.0 / 10     |   1.0 / 10    |
| **X_8** | 1.0 / 0.1    |   1.0 / 10    |

**X_1** and **X_2** are thus *Instrumental variables*, **X_3** and **X_4** are *Risk factors for the outcome* and **X_5** and **X_6** are *Confounders*.  

**X_7** and **X_8** are unobserved tail-end cofounders indicating rare treatment decisions for extreme propensity score values in each group. Untreated patients with very high propensity of treatment will be very likely to have **X_7**=1 (patients that should have been treated but weren't due to frailty). Treated patients with very low propensity of treatment will be very likely to have **X_8**=1 (patients that should not have been treated but were due to severe condition).

For each replication, observed covariates explained treatment with an AUC drawn randomly between 0.65 and 0.85 (average: 0.75).
